## morse-simulator 1.4

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)

set(PACKAGE_NAME morse)
set(PACKAGE_VERSION "1.4")

project(${PACKAGE_NAME})

# only available from cmake-2.8.4
if(COMMAND cmake_policy)
	if(${CMAKE_MAJOR_VERSION} EQUAL 2 AND ${CMAKE_MINOR_VERSION} EQUAL 8 AND ${CMAKE_PATCH_VERSION} GREATER 3)
		cmake_policy(SET CMP0017 OLD)
	endif()
endif()


option(BUILD_CORE_SUPPORT "Build and install morse core" ON)
option(BUILD_DOC_SUPPORT "Build and install morse documentation (Requiere Sphinx)" OFF)
option(BUILD_POCOLIBS_SUPPORT "Build pocolibs framework support" ON)
option(BUILD_YARP_SUPPORT "Build yarp framework support" ON)
option(BUILD_ROS_SUPPORT "Build ROS middleware support" ON)
option(BUILD_MOOS_SUPPORT "Build MOOS middleware support" ON)
option(BUILD_MAVLINK_SUPPORT "Build Mavlink middleware support" ON)
option(BUILD_HLA_SUPPORT "Build HLA middleware support. Also used for distributed HLA simulation." ON)
option(PYMORSE_SUPPORT "Build and install the Python bindings for MORSE." ON)

list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/config/)
find_package(PkgConfig REQUIRED)

set(PythonInterp_FIND_VERSION 3.3)
find_package(PythonInterp REQUIRED)

set(PythonLibs_FIND_VERSION "${PYTHON_VERSION_MAJOR}.${PYTHON_VERSION_MINOR}")
set(PythonLibs_FIND_VERSION_EXACT "${PYTHON_VERSION_MAJOR}.${PYTHON_VERSION_MINOR}")
find_package(PythonLibs REQUIRED)

set(ALL_C_PYTHON_MODULES "" CACHE STRING "" FORCE)

# Add python include and library directories
include_directories(${PYTHON_INCLUDE_DIRS})

EXECUTE_PROCESS(COMMAND
					${PYTHON_EXECUTABLE} -c "import distutils.sysconfig, sys; sys.stdout.write(distutils.sysconfig.get_python_lib(1,0,\"\"))"
					OUTPUT_VARIABLE PYTHON_INSTALL
					ERROR_VARIABLE PYTHON_STDERR
					RESULT_VARIABLE PYTHON_ERR
				)
if(NOT PYTHON_INSTDIR)
	SET(PYTHON_INSTDIR ${CMAKE_INSTALL_PREFIX}/${PYTHON_INSTALL}) 
endif(NOT PYTHON_INSTDIR)
if(WIN32)
    STRING(REGEX REPLACE "\\\\" "/" PYTHON_INSTDIR ${PYTHON_INSTDIR})
endif(WIN32)
MESSAGE(STATUS "will install python files in ${PYTHON_INSTDIR}")

# Compute revision
ADD_CUSTOM_TARGET(revisiontag ALL)
ADD_CUSTOM_COMMAND(TARGET revisiontag COMMAND ${CMAKE_COMMAND}
	   -DSOURCE_DIR=${CMAKE_CURRENT_SOURCE_DIR} 
	   -P ${CMAKE_CURRENT_SOURCE_DIR}/config/version.cmake)

if (BUILD_CORE_SUPPORT)
	INSTALL(FILES ${CMAKE_BINARY_DIR}/version.py DESTINATION ${PYTHON_INSTDIR}/morse/)
endif(BUILD_CORE_SUPPORT)

ADD_SUBDIRECTORY(src)

IF(BUILD_CORE_SUPPORT)
INSTALL (DIRECTORY data examples addons
	     DESTINATION ${CMAKE_INSTALL_PREFIX}/share/morse
         REGEX .*blend.$ EXCLUDE
         REGEX .*py.$ EXCLUDE
		 REGEX .*clients.* EXCLUDE
		)

IF(WIN32)
CONFIGURE_FILE(
   ${CMAKE_CURRENT_SOURCE_DIR}/bin/morse.in
   ${CMAKE_CURRENT_BINARY_DIR}/bin/morserun.py
   )
CONFIGURE_FILE(
   ${CMAKE_CURRENT_SOURCE_DIR}/bin/multinode_server.in
   ${CMAKE_CURRENT_BINARY_DIR}/bin/multinode_server.py
   )
CONFIGURE_FILE(
   ${CMAKE_CURRENT_SOURCE_DIR}/bin/morse_sync.in
   ${CMAKE_CURRENT_BINARY_DIR}/bin/morse_sync.py
   )
INSTALL(PROGRAMS
	   ${CMAKE_CURRENT_BINARY_DIR}/bin/morse_sync.py
       ${CMAKE_CURRENT_BINARY_DIR}/bin/morserun.py
       ${CMAKE_CURRENT_SOURCE_DIR}/bin/morse_inspector
       ${CMAKE_CURRENT_BINARY_DIR}/bin/multinode_server.py
       DESTINATION ${CMAKE_INSTALL_PREFIX}/bin
       )
ELSE(WIN32)
CONFIGURE_FILE(
	${CMAKE_CURRENT_SOURCE_DIR}/bin/morse.in
	${CMAKE_CURRENT_BINARY_DIR}/bin/morse
	)
CONFIGURE_FILE(
	${CMAKE_CURRENT_SOURCE_DIR}/bin/morseexec.in
	${CMAKE_CURRENT_BINARY_DIR}/bin/morseexec
	)
CONFIGURE_FILE(
	${CMAKE_CURRENT_SOURCE_DIR}/bin/multinode_server.in
	${CMAKE_CURRENT_BINARY_DIR}/bin/multinode_server
	)
CONFIGURE_FILE(
	${CMAKE_CURRENT_SOURCE_DIR}/bin/morse_sync.in
	${CMAKE_CURRENT_BINARY_DIR}/bin/morse_sync
	)
INSTALL(PROGRAMS
		${CMAKE_CURRENT_BINARY_DIR}/bin/morse
		${CMAKE_CURRENT_BINARY_DIR}/bin/morseexec
		${CMAKE_CURRENT_BINARY_DIR}/bin/morse_sync
		${CMAKE_CURRENT_SOURCE_DIR}/bin/morse_inspector
		${CMAKE_CURRENT_BINARY_DIR}/bin/multinode_server
		DESTINATION ${CMAKE_INSTALL_PREFIX}/bin
	    )
ENDIF(WIN32)
ENDIF()

ADD_SUBDIRECTORY(bindings)

###### Testing ######
include( CTest )
ADD_SUBDIRECTORY(testing)

IF (BUILD_DOC_SUPPORT)
### Doc target ###
CONFIGURE_FILE(
	${CMAKE_CURRENT_SOURCE_DIR}/doc/conf.py.in
	${CMAKE_CURRENT_BINARY_DIR}/doc/conf.py
	)

FIND_PROGRAM(SPHINX_BUILD NAMES sphinx-build)
IF (NOT SPHINX_BUILD)
	MESSAGE(FATAL_ERROR "Can't find sphinx-build : will not build the documentation")
ELSE()
	SET (CMAKE_DOC_OUT ${CMAKE_CURRENT_BINARY_DIR}/doc)
	SET (SPHINX_OUTPUT ${CMAKE_DOC_OUT}/html)
	SET (SPHINX_SRC ${CMAKE_DOC_OUT}/src)
	SET (SPHINX_LATEX_OUTPUT ${CMAKE_DOC_OUT}/tex)
	SET (SPHINX_MAN_OUTPUT ${CMAKE_DOC_OUT}/man)
	SET (SPHINX_FALSE_PYTHON_ENV ${CMAKE_CURRENT_BINARY_DIR}/fakeenv)

 	SET (PYTHON_DOC_ENV env PYTHONPATH=${CMAKE_CURRENT_BINARY_DIR}:${CMAKE_CURRENT_BINARY_DIR}/src:${SPHINX_FALSE_PYTHON_ENV}:${CMAKE_CURRENT_SOURCE_DIR}/src:${CMAKE_CURRENT_SOURCE_DIR}/testing:${CMAKE_CURRENT_SOURCE_DIR}/bindings/pymorse/src/:$$PYTHONPATH PYTHONDONTWRITEBYTECODE="morse" MORSESOURCE=${CMAKE_CURRENT_SOURCE_DIR} ${PYTHON_EXECUTABLE})
	SET (SPHINX_BUILD_ENV ${PYTHON_DOC_ENV} ${SPHINX_BUILD})

	# Copy the documentation in builddir, so we can include the generated part too
	ADD_CUSTOM_TARGET(
		copy_doc ALL
		COMMAND ${CMAKE_COMMAND} -E copy_directory ${CMAKE_CURRENT_SOURCE_DIR}/doc/morse ${SPHINX_SRC}/morse
		COMMAND ${CMAKE_COMMAND} -E copy_directory ${CMAKE_CURRENT_SOURCE_DIR}/doc/media ${SPHINX_SRC}/media
	)

	# Generate the documentation from the different components
	ADD_CUSTOM_TARGET(
		generate_doc ALL
		COMMAND ${PYTHON_DOC_ENV} ${CMAKE_CURRENT_SOURCE_DIR}/doc/tools/generate_doc
		WORKING_DIRECTORY ${SPHINX_SRC}/morse/user/
	)

	ADD_DEPENDENCIES(generate_doc copy_doc ${ALL_C_PYTHON_MODULES})

	# Populate the false python environment
	ADD_CUSTOM_TARGET(
		populate_false_env ALL
		COMMAND ${CMAKE_COMMAND} -E make_directory ${SPHINX_FALSE_PYTHON_ENV}
		COMMAND ${CMAKE_COMMAND} -E touch ${SPHINX_FALSE_PYTHON_ENV}/mathutils.py
		COMMAND ${CMAKE_COMMAND} -E touch ${SPHINX_FALSE_PYTHON_ENV}/bge.py
		COMMAND ${CMAKE_COMMAND} -E touch ${SPHINX_FALSE_PYTHON_ENV}/PhysicsConstraints.py

		COMMAND ${CMAKE_COMMAND} -E make_directory ${SPHINX_FALSE_PYTHON_ENV}/hla
		COMMAND ${CMAKE_COMMAND} -E touch ${SPHINX_FALSE_PYTHON_ENV}/hla/__init__.py

		COMMAND ${CMAKE_COMMAND} -E make_directory ${SPHINX_FALSE_PYTHON_ENV}/pymoos
		COMMAND ${CMAKE_COMMAND} -E touch ${SPHINX_FALSE_PYTHON_ENV}/pymoos/__init__.py
		COMMAND ${CMAKE_COMMAND} -E touch ${SPHINX_FALSE_PYTHON_ENV}/pymoos/MOOSCommClient.py

		COMMAND ${CMAKE_COMMAND} -E make_directory ${SPHINX_FALSE_PYTHON_ENV}/pymavlink/dialects/v10/
		COMMAND ${CMAKE_COMMAND} -E touch ${SPHINX_FALSE_PYTHON_ENV}/pymavlink/dialects/v10/__init__.py
		COMMAND ${CMAKE_COMMAND} -E touch ${SPHINX_FALSE_PYTHON_ENV}/pymavlink/dialects/v10/common.py
		COMMAND ${CMAKE_COMMAND} -E make_directory ${SPHINX_FALSE_PYTHON_ENV}/pymavlink/mavutil
		COMMAND ${CMAKE_COMMAND} -E touch ${SPHINX_FALSE_PYTHON_ENV}/pymavlink/__init__.py

		COMMAND ${CMAKE_COMMAND} -E touch ${SPHINX_FALSE_PYTHON_ENV}/yarp.py
		COMMAND ${CMAKE_COMMAND} -DSPHINX_FALSE_PYTHON_ENV=${SPHINX_FALSE_PYTHON_ENV} -P ${CMAKE_CURRENT_SOURCE_DIR}/config/generate_false_env.cmake
	)

	# GeNoM fake stuff
	FOREACH(lib genPos lwr niut pom platine spark stereopixel viam viman)
		ADD_CUSTOM_TARGET(
			populate_false_env_${lib} ALL
			COMMAND ${CMAKE_COMMAND} -E make_directory ${SPHINX_FALSE_PYTHON_ENV}/${lib}
			COMMAND ${CMAKE_COMMAND} -E touch ${SPHINX_FALSE_PYTHON_ENV}/${lib}/struct.py
			COMMAND ${CMAKE_COMMAND} -E touch ${SPHINX_FALSE_PYTHON_ENV}/${lib}/__init__.py
		)
		ADD_DEPENDENCIES(generate_doc populate_false_env_${lib})
	ENDFOREACH()


	ADD_DEPENDENCIES(copy_doc revisiontag)


	FIND_PROGRAM(SPHINX_APIDOC NAMES sphinx-apidoc)
	IF (SPHINX_APIDOC)
		ADD_CUSTOM_TARGET(
			generate_api_doc ALL
			COMMAND ${PYTHON_DOC_ENV} ${SPHINX_APIDOC} -f -o ${SPHINX_SRC}/morse/user/code ${CMAKE_CURRENT_SOURCE_DIR}/src
			COMMAND ${PYTHON_DOC_ENV} ${SPHINX_APIDOC} -f -o ${SPHINX_SRC}/morse/user/code ${CMAKE_CURRENT_SOURCE_DIR}/testing)
	ELSE()
		ADD_CUSTOM_TARGET(
			generate_api_doc ALL
			COMMAND ${CMAKE_COMMAND} -E echo "sphinx-apidoc not found : skipping api documentation"
		)
	ENDIF()
	ADD_DEPENDENCIES(generate_api_doc copy_doc populate_false_env)

	# Generate API doc if we have the sphinx-api tool

	ADD_CUSTOM_TARGET(
		doc ALL
		COMMAND ${SPHINX_BUILD_ENV} -b html
								    -c ${CMAKE_DOC_OUT}
									${SPHINX_SRC}/morse
								    ${SPHINX_OUTPUT}
	)
	ADD_DEPENDENCIES(doc generate_doc generate_api_doc)

	FIND_PROGRAM(GZIP NAMES gzip)
	IF (NOT GZIP)
		MESSAGE(STATUS "Can't find gzip : will not build man pages")
	ELSE()
		ADD_CUSTOM_TARGET(man ALL COMMAND ${SPHINX_BUILD_ENV} -b man
									-c ${CMAKE_CURRENT_BINARY_DIR}/doc
									   ${CMAKE_CURRENT_SOURCE_DIR}/doc/man
        								   ${SPHINX_MAN_OUTPUT} &&
						  ${GZIP} -f ${SPHINX_MAN_OUTPUT}/*.1)
		INSTALL(FILES ${SPHINX_MAN_OUTPUT}/morse.1.gz 
					  ${SPHINX_MAN_OUTPUT}/morse-run.1.gz 
					  ${SPHINX_MAN_OUTPUT}/morse-create.1.gz 
					  ${SPHINX_MAN_OUTPUT}/morse-import.1.gz 
					  ${SPHINX_MAN_OUTPUT}/morse-edit.1.gz 
					  ${SPHINX_MAN_OUTPUT}/morse-check.1.gz 
					  ${SPHINX_MAN_OUTPUT}/morse-add.1.gz 
					  ${SPHINX_MAN_OUTPUT}/morse-rm.1.gz 
					  ${SPHINX_MAN_OUTPUT}/morseexec.1.gz 
					  ${SPHINX_MAN_OUTPUT}/morse_sync.1.gz
					  ${SPHINX_MAN_OUTPUT}/multinode_server.1.gz
			DESTINATION ${CMAKE_INSTALL_PREFIX}/share/man/man1
		)
	ENDIF()

	INSTALL(DIRECTORY ${SPHINX_OUTPUT}
			DESTINATION ${CMAKE_INSTALL_PREFIX}/share/doc/morse
			REGEX .doctrees.* EXCLUDE
			REGEX _sources.* EXCLUDE
			REGEX .*.inv EXCLUDE
			REGEX .buildinfo EXCLUDE
			)

	ADD_CUSTOM_TARGET(
		latex_doc 
		COMMAND ${SPHINX_BUILD_ENV} -b latex
									-c ${CMAKE_DOC_OUT}
									${SPHINX_SRC}/morse
									${SPHINX_LATEX_OUTPUT}
	)
ENDIF()
ENDIF()


### Uninstall ###
configure_file("${CMAKE_HOME_DIRECTORY}/config/cmake_uninstall.cmake.in" "cmake_uninstall.cmake" IMMEDIATE @ONLY)
add_custom_target(uninstall "${CMAKE_COMMAND}" -P "cmake_uninstall.cmake")

=== testing/CMakeLists.txt ===
macro(add_morse_test name)
	set(full_name ${CMAKE_CURRENT_SOURCE_DIR}/${name})
	string(REPLACE "${CMAKE_SOURCE_DIR}/testing/" "" test_name ${full_name})
	add_test(NAME ${test_name} COMMAND ${PYTHON_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/${name}.py)
endmacro()

if (BUILD_CORE_SUPPORT)
	add_subdirectory(base)
	add_subdirectory(failures)
	add_subdirectory(robots/rmax)
	add_subdirectory(robots/segway)
	add_subdirectory(robots/submarine)
	add_subdirectory(robots/pr2)
	add_subdirectory(robots/pionner3dx)
	add_subdirectory(human)
endif()

if (BUILD_ROS_SUPPORT)
	add_subdirectory(middlewares/ros)
endif()

if (BUILD_YARP_SUPPORT)
	add_subdirectory(middlewares/yarp)
endif()

=== src/morse/CMakeLists.txt ===

if(BUILD_CORE_SUPPORT)
INSTALL(FILES __init__.py environments.py
        DESTINATION ${PYTHON_INSTDIR}/morse
        )

INSTALL(DIRECTORY core actuators helpers blender services robots testing
        DESTINATION ${PYTHON_INSTDIR}/morse
        REGEX .*py.$ EXCLUDE
        )

ADD_SUBDIRECTORY(builder)
ADD_SUBDIRECTORY(modifiers)
ADD_SUBDIRECTORY(sensors)
endif()

ADD_SUBDIRECTORY(multinode)
ADD_SUBDIRECTORY(middleware)

=== testing/base/CMakeLists.txt ===
# Base concept 

add_morse_test(base_testing)
add_morse_test(renaming_testing)
add_morse_test(builder_wheeled_robot)
add_morse_test(friction_testing)
add_morse_test(levels)

# Sensor

add_morse_test(accelerometer_testing)
add_morse_test(airspeed_testing)
add_morse_test(armature_pose_testing)
add_morse_test(attitude_testing)
add_morse_test(barometer_testing)
add_morse_test(battery_testing)
add_morse_test(depth_camera_testing)
add_morse_test(gps_testing)
add_morse_test(gyroscope_testing)
add_morse_test(magnetometer_testing)
add_morse_test(odometry_testing)
add_morse_test(pose_testing)
add_morse_test(proximity_testing)
add_morse_test(radar_altimeter_testing)
add_morse_test(sick_testing)
add_morse_test(semantic_camera_testing)
add_morse_test(semantic_camera_tag_testing)
add_morse_test(semantic_camera_relative_testing)
add_morse_test(thermometer_testing)
add_morse_test(search_and_rescue_testing)
add_morse_test(velocity_testing)
add_morse_test(video_camera_testing)
add_morse_test(collision_testing)

# Actuator

add_morse_test(armature_testing)
add_morse_test(external_force_testing)
add_morse_test(destination_testing)
add_morse_test(drag_testing)
add_morse_test(gripper_testing)
add_morse_test(light_testing)
add_morse_test(orientation_testing)
add_morse_test(orientation_speed_testing)
add_morse_test(rotorcraft_waypoint_testing)
add_morse_test(steer_force_testing)
add_morse_test(stabilized_quadrirotor_testing)
add_morse_test(teleport_testing)
add_morse_test(vw_testing)
add_morse_test(waypoint_testing)
add_morse_test(xyw_testing)

# Sensor + Actuator 

add_morse_test(ptu_testing)
add_morse_test(multiple_ptu_testing)

# Modifier

add_morse_test(ned_testing)
add_morse_test(utm_testing)
add_morse_test(ecef_testing)
add_morse_test(geodetic_testing)
add_morse_test(pose_noise_testing)
add_morse_test(imu_noise_testing)

# Services

add_morse_test(communication_service_testing)

add_morse_test(socket_sync_testing)
add_morse_test(time_scale_testing)

=== testing/failures/CMakeLists.txt ===
add_morse_test(invalid_builder_syntax)

=== testing/human/CMakeLists.txt ===
add_morse_test(human_base)
add_morse_test(human_ik)
add_morse_test(multiple_human)

=== examples/clients/arm/Makefile ===
# Makefile to compile control scripts

# Location of include libraries
#ROBOTPKG_BASE = $(HOME)/openrobots

CC = g++

CFLAGS = -g -I$(ROBOTPKG_BASE)/include
LDFLAGS = -L$(ROBOTPKG_BASE)/lib -lYARP_init -lYARP_OS -Wl,-rpath,$(ROBOTPKG_BASE)/lib
POCOLIBSFLAGS = -lposterLib


MOTION = agv_motion-1.0
DESTINATION = atrv_destination-1.0
CAMERAS = atrv_dest_cams-1.0
CONTROL = atrv_status-1.0
GRID = grid_move-1.0
LWR_CLIENT = pocolibs_lwr_client

all: $(MOTION) $(DESTINATION) $(CAMERAS) $(CONTROL) $(GRID)

$(MOTION): $(MOTION).o
	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $^

$(DESTINATION): $(DESTINATION).o
	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $^

$(CAMERAS): $(CAMERAS).o
	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $^

$(CONTROL): $(CONTROL).o
	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $^

$(GRID): $(GRID).o
	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $^

%.o: %.cpp
	$(CC) $(CFLAGS) $(LDFLAGS) -c -o $@ $^

$(LWR_CLIENT): $(LWR_CLIENT).cpp
	@echo "COMPILING ($@ C)"
#$(CC) -c $@.c $(CFLAGS)
#ld -o $@ $@.o $(LDFLAGS)
	$(CC) -g -o $@ $^ $(CFLAGS) $(LDFLAGS) $(POCOLIBSFLAGS)


tags:
	ctags *c *.h

clean:
	-rm -f *.o

distclean:	clean
	rm -f ${MOTION} ${DESTINATION} ${CAMERAS} ${CONTROL}

.PHONY: all clean tags

=== examples/clients/atrv/Makefile ===
# Makefile to compile control scripts

# Location of include libraries
#ROBOTPKG_BASE = $(HOME)/openrobots

CC = g++

CFLAGS = -g -I$(ROBOTPKG_BASE)/include
LDFLAGS = -L$(ROBOTPKG_BASE)/lib -lYARP_init -lYARP_OS -Wl,-rpath,$(ROBOTPKG_BASE)/lib
POCOLIBSFLAGS = -lposterLib


MOTION = agv_motion-1.0
DESTINATION = atrv_destination-1.0
CAMERAS = atrv_dest_cams-1.0
CONTROL = atrv_status-1.0
GRID = grid_move-1.0
POCO_CLIENT = pocolibs_movement_client
PLATINE_CLIENT = pocolibs_platine_client

all: $(MOTION) $(DESTINATION) $(CAMERAS) $(CONTROL) $(GRID)

$(MOTION): $(MOTION).o
	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $^

$(DESTINATION): $(DESTINATION).o
	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $^

$(CAMERAS): $(CAMERAS).o
	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $^

$(CONTROL): $(CONTROL).o
	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $^

$(GRID): $(GRID).o
	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $^

%.o: %.cpp
	$(CC) $(CFLAGS) $(LDFLAGS) -c -o $@ $^

$(POCO_CLIENT): $(POCO_CLIENT).cpp
	@echo "COMPILING ($@ C)"
#$(CC) -c $@.c $(CFLAGS)
#ld -o $@ $@.o $(LDFLAGS)
	$(CC) -g -o $@ $^ $(CFLAGS) $(LDFLAGS) $(POCOLIBSFLAGS)

$(PLATINE_CLIENT): $(PLATINE_CLIENT).cpp
	@echo "COMPILING ($@ C)"
#$(CC) -c $@.c $(CFLAGS)
#ld -o $@ $@.o $(LDFLAGS)
	$(CC) -g -o $@ $^ $(CFLAGS) $(LDFLAGS) $(POCOLIBSFLAGS)


tags:
	ctags *c *.h

clean:
	-rm -f *.o

distclean:	clean
	rm -f ${MOTION} ${DESTINATION} ${CAMERAS} ${CONTROL}

.PHONY: all clean tags

=== src/morse/builder/CMakeLists.txt ===

FILE(GLOB PYTHON_FILES *.py)
INSTALL(FILES ${PYTHON_FILES}
        DESTINATION ${PYTHON_INSTDIR}/morse/builder
        )

INSTALL(DIRECTORY robots
        DESTINATION ${PYTHON_INSTDIR}/morse/builder
        REGEX .*py.$ EXCLUDE
        )

=== src/morse/middleware/CMakeLists.txt ===
macro(install_mw name)
	string(TOUPPER ${name} NAME)
	if(BUILD_${NAME}_SUPPORT)
		install(DIRECTORY ${name}
				DESTINATION ${PYTHON_INSTDIR}/morse/middleware
				REGEX .*.py.$ EXCLUDE)
		
		file(GLOB ${NAME}_SRCS ${name}_*.py)
		install(FILES ${${NAME}_SRCS}
				DESTINATION ${PYTHON_INSTDIR}/morse/middleware)
	endif()
endmacro()

if (BUILD_CORE_SUPPORT)
INSTALL(FILES __init__.py abstract_datastream.py socket_datastream.py text_datastream.py socket_request_manager.py 
	    DESTINATION ${PYTHON_INSTDIR}/morse/middleware
		)

INSTALL(DIRECTORY sockets
		 DESTINATION ${PYTHON_INSTDIR}/morse/middleware
		 REGEX .*.py.$ EXCLUDE)
endif()


IF(BUILD_POCOLIBS_SUPPORT)
	ADD_SUBDIRECTORY(pocolibs)
	INSTALL(FILES pocolibs_datastream.py pocolibs_request_manager.py
			DESTINATION ${PYTHON_INSTDIR}/morse/middleware)
ENDIF(BUILD_POCOLIBS_SUPPORT)

install_mw(yarp)
install_mw(ros)
install_mw(moos)
install_mw(hla)
install_mw(mavlink)

=== src/morse/modifiers/CMakeLists.txt ===
# install python files
FILE(GLOB PYTHON_FILES *.py)
INSTALL(FILES ${PYTHON_FILES}
        DESTINATION ${PYTHON_INSTDIR}/morse/modifiers)

=== src/morse/sensors/CMakeLists.txt ===
#PYTHON_ADD_MODULE(sickc sickcmodule.c)
#INSTALL(TARGETS sickc DESTINATION ${PYTHON_INSTDIR}/morse/sensors)
		

PYTHON_ADD_MODULE(zbuffertodepth zbuffertodepth.c)
INSTALL(TARGETS zbuffertodepth DESTINATION ${PYTHON_INSTDIR}/morse/sensors)

PYTHON_ADD_MODULE(zbufferto3d zbufferto3d.c)
INSTALL(TARGETS zbufferto3d DESTINATION ${PYTHON_INSTDIR}/morse/sensors)

PYTHON_ADD_MODULE(_magnetometer magnetometer.c GeomagnetismLibrary.c)
INSTALL(TARGETS _magnetometer DESTINATION ${PYTHON_INSTDIR}/morse/sensors)
INSTALL(FILES WMM.COF DESTINATION ${CMAKE_INSTALL_PREFIX}/share/morse/data)

# install python files
FILE(GLOB PYTHON_FILES *.py)
INSTALL(FILES ${PYTHON_FILES} DESTINATION ${PYTHON_INSTDIR}/morse/sensors)

=== debian/changelog ===
morse-simulator (1.4-6build1) focal; urgency=medium

  * No-change rebuild to build with python3.8.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 25 Jan 2020 04:37:19 +0000

morse-simulator (1.4-6) unstable; urgency=medium

  * Team upload.
  * Drop unneeded build-dependency on python-concurrent.futures
    (Closes: #943185).
  * Add missing build-dependency on dh-python.
  * Upgrade to debhelper-compat (= 12).
  * Add Rules-Requires-Root: no.
  * Update Standards-Version to 4.4.1.
  * Drop unneeded versions for dependencies.
  * Fix up copyright file.

 -- Stuart Prescott <stuart@debian.org>  Tue, 21 Jan 2020 01:11:41 +1100

morse-simulator (1.4-5) unstable; urgency=medium

  * Team upload.

  [ Micha David Rosenbaum ]
  * Fix the FTBFS by replacing pngmath with imgmath Sphinx module.
    (Closes: #921897)

  [ Andreas Tille ]
  * cme fix dpkg-control
  * debhelper 11
  * Document skip upstream build time test
  * Secure URI in d/copyright
  * Add debian/gbp.conf: pristine-tar = False

 -- Andreas Tille <tille@debian.org>  Fri, 22 Feb 2019 10:52:14 +0100

morse-simulator (1.4-4) unstable; urgency=medium

  * Rename the variable to build with python 3.7
    (Closes: #904343)

 -- Sylvestre Ledru <sylvestre@debian.org>  Sat, 05 Jan 2019 19:04:06 +0100

morse-simulator (1.4-3) unstable; urgency=medium

  * Fix the FTBFS by adding the version.py file from usptream
    (Closes: #853557)
  * Package moved on salsa
  * Standards-Version updated to 4.1.3
  * Move to compat mode 8
  * Fix priority-extra-is-replaced-by-priority-optional
  * Explicit python3-setuptools as dep
  * Rename morse => morsesim to avoid a conflict
    For now, it still contains a symlink from morse to morseim
    I will remove it later.
    (Closes: #861028)
  * Disable the sphinx ext vimeo & gallery until
    https://github.com/morse-simulator/morse/issues/792 is fixed

  [ Séverin Lemaignan ]
  * Relax the need for Sphinx 1.3 as the original issue (#792711) has been
    fixed upstream

 -- Sylvestre Ledru <sylvestre@debian.org>  Sun, 15 Apr 2018 18:40:27 +0200

morse-simulator (1.4-2) unstable; urgency=medium

  * Fix a bad dependency (numpy)
  * Update the minimal version of Blender (2.64)
  * Update the minimal version of Python (3.3)

  [ Séverin Lemaignan ]
  * Moved to github
  * Update of the homepage
  * Update of the VCS field

 -- Sylvestre Ledru <sylvestre@debian.org>  Wed, 17 Feb 2016 12:09:21 +0100

morse-simulator (1.4-1) unstable; urgency=medium

  * New upstream release
  * Add numpy as dependency
  * Add --fail-missing to dh_install

 -- Sylvestre Ledru <sylvestre@debian.org>  Tue, 16 Feb 2016 10:47:06 +0100

=== debian/control ===
Source: morse-simulator
Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Sylvestre Ledru <sylvestre@debian.org>,
           Séverin Lemaignan <severin@guakamole.org>
Section: science
Priority: optional
Build-Depends: debhelper-compat (= 12),
               cmake,
               dh-python,
               python3-dev,
               python3-sphinx,
               pkg-config,
               python3-setuptools
Standards-Version: 4.4.1
Vcs-Browser: https://salsa.debian.org/science-team/morse-simulator
Vcs-Git: https://salsa.debian.org/science-team/morse-simulator.git
Homepage: http://morse-simulator.github.io/
Rules-Requires-Root: no

Package: morse-simulator
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         blender,
         ${python3:Depends},
         python3-morse-simulator (= ${binary:Version}),
         morse-simulator-data,
         python3-numpy
Recommends: morse-simulator-doc
Conflicts: morse
Description: Multi-OpenRobot Simulation Engine
 List of morse features:
  * Versatile simulator for generic mobile robots simulation
    (single or multi robots),
  * Realistic and dynamic environments (interaction with other agents like
    humans or objects),
  * Based on well known and widely adopted open source projects (Blender for 3D
    rendering + UI, Bullet for physics simulation, dedicated robotic
    middlewares for communications + robot hardware support),
  * Seamless workflow: since the simulator rely on Blender for both modeling
    and the real time 3D engine, creating and modifying a simulated scene is
    straightforward.
  * Entirely scriptable in Python,
  * Adaptable to various level of simulation realism (for instance the
    simulation of exteroceptive sensors like cameras or a direct access to
    higher level representations of the world, like labeled artifacts),
  * Currently compatible with ROS, YARP and the LAAS OpenRobots robotics
    frameworks,
  * Easy to integrate to other environments via a simple socket interface,
  * Fully open source, BSD license.

Package: morse-simulator-data
Architecture: all
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Multi-OpenRobot Simulation Engine
 List of morse features:
  * Versatile simulator for generic mobile robots simulation
    (single or multi robots),
  * Realistic and dynamic environments (interaction with other agents like
    humans or objects),
  * Based on well known and widely adopted open source projects (Blender for 3D
    rendering + UI, Bullet for physics simulation, dedicated robotic
    middlewares for communications + robot hardware support),
  * Seamless workflow: since the simulator rely on Blender for both modeling
    and the real time 3D engine, creating and modifying a simulated scene is
    straightforward.
  * Entirely scriptable in Python,
  * Adaptable to various level of simulation realism (for instance the
    simulation of exteroceptive sensors like cameras or a direct access to
    higher level representations of the world, like labeled artifacts),
  * Currently compatible with ROS, YARP and the LAAS OpenRobots robotics
    frameworks,
  * Easy to integrate to other environments via a simple socket interface,
  * Fully open source, BSD license.
 .
 This package contains morse data.

Package: morse-simulator-doc
Architecture: all
Section: doc
Depends: ${shlibs:Depends},
         ${misc:Depends},
         libjs-jquery,
         libjs-underscore
Description: Multi-OpenRobot Simulation Engine - Documentation
 List of morse features:
  * Versatile simulator for generic mobile robots simulation
    (single or multi robots),
  * Realistic and dynamic environments (interaction with other agents like
    humans or objects),
  * Based on well known and widely adopted open source projects (Blender for 3D
    rendering + UI, Bullet for physics simulation, dedicated robotic
    middlewares for communications + robot hardware support),
  * Seamless workflow: since the simulator rely on Blender for both modeling
    and the real time 3D engine, creating and modifying a simulated scene is
    straightforward.
  * Entirely scriptable in Python,
  * Adaptable to various level of simulation realism (for instance the
    simulation of exteroceptive sensors like cameras or a direct access to
    higher level representations of the world, like labeled artifacts),
  * Currently compatible with ROS, YARP and the LAAS OpenRobots robotics
    frameworks,
  * Easy to integrate to other environments via a simple socket interface,
  * Fully open source, BSD license.
 .
 This package contains the documentation.

Package: python3-morse-simulator
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         ${python3:Depends}
Conflicts: morse
Description: Multi-OpenRobot Simulation Engine
 List of morse features:
  * Versatile simulator for generic mobile robots simulation
    (single or multi robots),
  * Realistic and dynamic environments (interaction with other agents like
    humans or objects),
  * Based on well known and widely adopted open source projects (Blender for 3D
    rendering + UI, Bullet for physics simulation, dedicated robotic
    middlewares for communications + robot hardware support),
  * Seamless workflow: since the simulator rely on Blender for both modeling
    and the real time 3D engine, creating and modifying a simulated scene is
    straightforward.
  * Entirely scriptable in Python,
  * Adaptable to various level of simulation realism (for instance the
    simulation of exteroceptive sensors like cameras or a direct access to
    higher level representations of the world, like labeled artifacts),
  * Currently compatible with ROS, YARP and the LAAS OpenRobots robotics
    frameworks,
  * Easy to integrate to other environments via a simple socket interface,
  * Fully open source, BSD license.
 .
 This package contains the Python extension.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

%:
	dh $@ --with python3

override_dh_auto_configure:
	dh_auto_configure -- -DBUILD_DOC_SUPPORT=ON -DPYTHON_EXECUTABLE=/usr/bin/python3 \
		 -DCPACK_DEBIAN_PACKAGE_DEPENDS=python3-all-dev -DPYMORSE_SUPPORT=ON

override_dh_install:
	cd debian/tmp/usr/bin/ && mv morse morsesim && ln -s morsesim morse
	dh_install
	rm -fr $$(find $(CURDIR) -name '__pycache__')
	if test -d $(CURDIR)/debian/morse-simulator-doc/usr/share/doc/morse/html/_static/; then \
		cd $(CURDIR)/debian/morse-simulator-doc/usr/share/doc/morse/html/_static/ && \
		rm -f jquery.js underscore.js && \
		ln -s /usr/share/javascript/jquery/jquery.js && \
		ln -s /usr/share/javascript/jquery/underscore.js; \
	fi

override_dh_missing:
	dh_missing --fail-missing

override_dh_auto_build:
	cp version.py obj-*/
	dh_auto_build

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	echo "Skip upstream build time test"
endif

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/morse-$1\.tar\.gz/ \
  https://github.com/morse-simulator/morse/tags .*/v?(\d\S*)\.tar\.gz debian uupdate
